unit mp416u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button6: TButton;
    Memo1: TMemo;
    Timer1: TTimer;
    Edit1: TEdit;
    Edit2: TEdit;
    Timer2: TTimer;
    Button7: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button7Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hd416:ulong; //
  state:integer;

//豸

function MP416_OpenDevice(dev_num:ulong):ulong; stdcall; external 'Mp416.dll';  

function MP416_CloseDevice(hDevice:ulong):ulong; stdcall; external 'Mp416.dll';

//************************************************************************************
//AD
function  MP416_AD(hDevice,ch,gain,sidi,naver:ulong):ulong; stdcall; external 'Mp416.dll';

function MP416_AD_CAL(hDevice:ulong):ulong; stdcall; external 'Mp416.dll';

//************************************************************************************
//DIO
function MP416_DI(hDevice:ulong):ulong; stdcall; external 'Mp416.dll';

function MP416_DO(hDevice:ulong;DO_Data:ulong):ulong; stdcall; external 'Mp416.dll';

//************************************************************************************
//
function MP416_CMode(hDevice,cntch,cntmode:ulong):ulong; stdcall; external 'Mp416.dll';

function MP416_CRead(hDevice,cntch:ulong;CState:plongint):ulong; stdcall; external 'Mp416.dll';

//************************************************************************************
//庯
function MP416_PMode(hDevice,pch,pdata,pmode,peb:ulong):ulong; stdcall; external 'Mp416.dll';

function MP416_PState(hDevice,pch:ulong):ulong; stdcall; external 'Mp416.dll';
//************************************************************************************
implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
hd416:= MP416_OpenDevice(0); //get handle

If hd416<> $ffffffff Then
     begin
    Form1.Caption:='MP416 Testing Program wwlab (c) 2007.2.     Device Open OK!';
    state:=0;
    end
 else
    begin
    Form1.caption:='Device Open Eorror!';
    end;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if state=0 then
begin
 button1.Caption:='ֹͣAD' ;
 state:=1;
 //ûڿʼ֮ǰһMP416_AD_CAL()ADһУ
 MP416_AD_CAL(hd416);
 timer1.Enabled:=true
 end
 
else
begin
 button1.Caption:='AD';
 state:=0;
 timer1.Enabled:=false;
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i:integer;
ADData:longint;
Vol:real;
tmp:string;
begin
memo1.Clear;
for i:=0 to 15 do
begin
ADData:=MP416_AD(hd416,i,2,0,1);
Vol:=(ADData-32768.0)*5.0/32768.0;
tmp:='CH' +inttostr(i)+'   ' +format('%4d',[ADData])+'   ' + format('%.3f',[Vol])+'V' ;
memo1.Lines.Add(tmp);
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 MP416_DO(hd416,$ffff);
 MP416_DO(hd416,$55aa);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
DIData:longint;

begin
DIData:=MP416_DI(hd416);
edit1.Text :='0x'+inttohex(DIData,2);

end;

procedure TForm1.Button4Click(Sender: TObject);


begin
MP416_CMode(hd416,0,0);
timer2.Enabled :=true;
//MP416_CMode(hd416,1,0);
end;



procedure TForm1.Timer2Timer(Sender: TObject);
var
 Count:longint;
 a:array[0..6] of longint;
begin
Count:=MP416_CRead(hd416,0,@a[0]);
if Count=-1 then
begin
edit2.Text :='Over!';
end
else
begin
//Count1:=MP416_CRead(hd416,1,@a[1]);
edit2.Text :='ʱ0'+inttostr(Count);
end;

end;

procedure TForm1.Button7Click(Sender: TObject);
var i:integer;
begin
//Ե
//for i:=0 to 10000   do
//MP416_PMode(hd416,0,1000,1,1);

//Է  Ƶ1MHz
MP416_PMode(hd416,0,10,0,1);
end;



end.
