

//opem MP416
extern "C" HANDLE __declspec(dllimport)  __stdcall MP416_OpenDevice(long dev_num);
//close device
extern "C" long __declspec(dllimport)  __stdcall MP416_CloseDevice(HANDLE hDevice1);


//********************************************
//get board info
//model or type in *bStr
extern "C" long __declspec(dllimport)  __stdcall MP416_Info(HANDLE hDevice,char *modle);


//****************************************************************************
//for AD

//*****************************************************************
//sam a single channel with average times=naver
//ch=0-15 , selected input
//gain: selected input range, 0,1,2 via: 5/10/B5 V
//sidi: not using by MP416
//return data=0-4095, 12bit ad data, if -1 error
//naver: average times, =0-100, if 0 aver times=1
//caldata is get by MP416_CAL is a long caldata[100]
//extern "C" long __declspec(dllimport)  __stdcall MP416_AD(HANDLE hDevice,long ch,long gain,long sidi,long naver,long *caldata);
extern "C" long __declspec(dllimport)  __stdcall MP416_AD(HANDLE hDevice,long ch,long gain,long sidi,long naver);


//Cal AD for Gain=gain, return zero data zdata, gain data: gdata
//extern "C" long __declspec(dllimport)  __stdcall MP416_AD_CAL(HANDLE hDevice,long gain,long *zdata, long *gdata);
//extern "C" long __declspec(dllimport)  __stdcall MP416_AD_CAL(HANDLE hDevice,long *caldata);
extern "C" long __declspec(dllimport)  __stdcall MP416_AD_CAL(HANDLE hDevice);



//end AD

//****************************************************************************
//DIO
//get 16bit DI data, data return by MP416_DI
extern "C" long __declspec(dllimport)  __stdcall MP416_DI(HANDLE hDevice1);
//set 16bit DO data=dodata
extern "C" long __declspec(dllimport)  __stdcall MP416_DO(HANDLE hDevice1,long dodata);



//*****************************************************************************************************
//counter
///start counter 
//cmode=0: set cnt is counter mode
//     =1: set Freq. measuring mode timer=1S
//     =2: Freq. time=100mS
//     =3: Measure Pulse's Poseedge time wideth
//cntch=0,1 sel cnt channel;
extern "C" long __declspec(dllimport)  __stdcall MP416_CMode(HANDLE hDevice,long cntch,long cntmode);

//read cnt data 
//return if -1 : cnt overflow
//*CState, using at mode1,2,3  =1 Measuring is running  / =0: end
extern "C" long __declspec(dllimport)  __stdcall MP416_CRead(HANDLE hDevice, long cntch,long *CState);


//****************************************************************************************************
// for pulse out

//poll state, Using only for mode=1 
//reutrn pout state, =0 end /  =1 : pout=1
extern "C" long __declspec(dllimport)  __stdcall MP416_PState(HANDLE hDevice,long pch);

//set mode and run
//pch=0,1
//pmode=0,1 , 0: square wave / 1: single pulse
//peb=1: enable pout / =0 : out as DO out
//pdata: 24bit data = 0-FFFFFFH /based clk =10M
extern "C" long __declspec(dllimport)  __stdcall MP416_PMode(HANDLE hDevice,long pch,long pdata,long pmode,long peb);


//**********************************************************************************
//da
//set da data
//dch=0:da channel0 /1:da channel 1
//dadata=0-4095: 12bit DA data
extern "C" long __declspec(dllimport)  __stdcall MP416_DA_Data(HANDLE hDevice1,long dch,long dadata);

//set DA Mode
//dgs: 0: out 0-10V / 1: +/-5V
extern "C" long __declspec(dllexport)  __stdcall MP416_DA_Mode(HANDLE hDevice1,long dgs0,long dgs1);



//**********************************************************************************
//read a byte from hardware
extern "C" long __declspec(dllimport)  __stdcall MP416_inb(HANDLE hdevice,int adr);
//read a word from hardware
extern "C" long __declspec(dllimport)  __stdcall MP416_inw(HANDLE hdevice,int adr);
//write byte
extern "C" long __declspec(dllimport)  __stdcall MP416_outb(HANDLE hdevice,long adr,long data1);
//write word
extern "C" long __declspec(dllimport)  __stdcall MP416_outw(HANDLE hdevice,long adr,long data1);
////////////////////////end
//*****************************************************************
//sam multi channel from stch to endch
//gain: selected input range, 0,1,2 via: 5/10/B5 V
//sidi: not using by MP416
//return 0 ok, if -1 error
//*addata is long addata[16], is return ad data, addata[0] stch's data,addata[1] (stch+1)'s data, 
//extern "C" long __declspec(dllimport)  __stdcall MP416_AD_Scan(HANDLE hDevice,long stch,long endch,long gain,long sidi,long *addata);

extern "C" long __declspec(dllimport)  __stdcall MP416_DataWrite(HANDLE hDevice,long *wData,long wLen);
extern "C" long __declspec(dllimport)  __stdcall MP416_DataRead(HANDLE hDevice,long *rData);
