// ts416.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <sys/timeb.h>


//////////////////////////////////////////////////////////////////////////////
//added lib of MP416
#pragma comment(lib,"MP416.lib")

#include "MP416.h"


struct timeb st,et;


HANDLE hDevice=INVALID_HANDLE_VALUE;
HANDLE hDevice1=INVALID_HANDLE_VALUE;

long ddk[200];




int main(int argc, char* argv[])
{
	
	int i=0;
	int j;
	char a[80];
    long gate=0;	
    

  //open device
	printf("Open Device MP416........");

	hDevice=MP416_OpenDevice(0);

	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		printf("error open USB Deivce\n");
		Beep(1000,300);
		getch();
		//exit(0);
	}
    else
	{  
		printf("Device Num:%d\n",hDevice);
	}
	
   
	
  	

    //get info of MP416
    i=MP416_Info(hDevice,a);
	printf("MP416's Board Design Infomation:%s\n",a);


	

    getch();

//	exit(0);

    
	////////////////////////////////////////////////////////////////////////
	//test based io func, this function is not suggested using by USER!

	//do{	
	//write a byte
	MP416_outb(hDevice,6,0x55);
    MP416_outb(hDevice,7,0xaa);
	//}while(!kbhit());

	//read a byte
	printf("8 bit IO in:%x %x\n",MP416_inb(hDevice,6),MP416_inb(hDevice,7));
   
	//write a word
	MP416_outw(hDevice,6,0x55aa);
	//read a word
	printf("16bit IO in:%x\n",MP416_inw(hDevice,6));
   
    
    printf("Using Dio function.......");
	MP416_DO(hDevice,0x5aa5); 
    printf("Set=5aa5  read=%x\n",MP416_DI(hDevice));



    

    ///////////////////////////////////////////////////////////////////////////
	//testing AD
    //long addata[16];
	long ch=0;
    long gain=0;
    long naver=1;
    double v,vb,vb10,v10;
    long k=0;
	double a1=0;
	double a2=0;
	double a3=0;
	double a4=0;
	long z5=0;
	long g5=0;
	long z10=0;
	long g10=0;
	long zb5=0;
	long gb5=0;
	long zb10=0;
	long gb10=0;

//goto tcnt;

	MP416_AD_CAL(hDevice);//,ddk);
    MP416_DataRead(hDevice,ddk);

	//set data
	z5=ddk[0];
	g5=ddk[1];
    z10=ddk[2];
	g10=ddk[3];
    zb5=ddk[4];
	gb5=ddk[5];
    zb10=ddk[6];
	gb10=ddk[7];


	printf("cal 5V z=%d   g=%d   delta G=%d\n",z5,g5,g5-65536);
 	printf("cal 10V z=%d   g=%d\n",z10,g10);
    printf("cal B5V z=%d   g=%d\n",zb5,gb5);
    printf("cal B10V z=%d   g=%d\n",zb10,gb10);


    
	//speed
	printf("sam 5000 point  1 avgerage.......");
    ftime(&st);

	for(i=0;i<5000;i++)
	{
		MP416_AD(hDevice,0,0,0,1);
		
	}
			
		//MP416_DI(hDevice);

	ftime(&et);

	i=st.time;
	i=i*1000;
	i=i + st.millitm;

	j=et.time;
	j=j*1000;
	j=j + et.millitm;

	printf("end  time=%d mS  , Speed=%5.1fHz\n",j-i,(double)5000/(double)(j-i)*1000.0);   //et.time-st.time);



	naver=1;
    printf("st AD......................\n");


	getch();
	
	
   printf("stop AD......................\n");

//pp:

	gain=0;
    ch=0;
    
    

	for(j=0;j<20;j++)
	{

		//AD sinlge channel
		i=MP416_AD(hDevice,0,gain,0,naver);




		v=(double)i*5000.0/65535.0;
		vb=(double)(i-32768)*5000.0/32768.0;
        v10=(double)i*10000.0/65535.0;
		vb10=(double)(i-32768)*10000.0/32768.0;
       

		printf("AD data=%d    V5:%6.1f   V10:%6.1f   VB5:%7.1f   VB10:%7.1f\n",i,v,v10,vb,vb10);

    }
//goto pp;




	getch();



	
//////////////////////////////////////////////////////////////////////////////////////////////////
//test timer out
//set mode

	j=0;   
	
		//do=ff;
		MP416_DO(hDevice,0xffff);

	///////////////////////////////////////////////////////////////////////////
	//testing 24bit counter as Freq: 0-1MHz
    printf("\n\n--------------------------------------------------------------------\n"); 
  

   

    MP416_PMode(hDevice,1,1000,0,1);	 //ch1 sq wave

       
	   
	   MP416_PMode(hDevice,0,1000000,1,1);

	   //Sleep(1);
	   do{
		   //i=MP416_inb(hDevice,0x16) & 1;
		   i=MP416_PState(hDevice,0);
		   printf("%5d",i);
	   }while(i!=0);

	   
	
    


    getch();




//8888888888888888888888888888888888888888888888888888888


	MP416_DO(hDevice,0x0); //high

	long l1=0;
	long l2=0;
	
	
    
	MP416_DO(hDevice,0x3000); //high
	
    MP416_CMode(hDevice,0,0);  
    MP416_CMode(hDevice,1,0);

    printf(" CH0 CRead=%d.....", MP416_CRead(hDevice,0,&gate));
    printf(" Ch1 CRead=%d.....\n", MP416_CRead(hDevice,1,&gate));
   
	printf("Gen 999 pulse ......\n");
	//gate=1
	for(l1=0;l1<999;l1++)
	{
	    MP416_DO(hDevice,0xf000); //high
	    MP416_DO(hDevice,0x3000); //low
	}

    printf(" CH0 CRead=%d.....", MP416_CRead(hDevice,0,&gate));
    printf(" Ch1 CRead=%d.....\n", MP416_CRead(hDevice,1,&gate));
   	
	
	
   printf("-------------------Freq.-----------------------\n");

   long ercnt=0;


   MP416_PMode(hDevice,0,1000,0,1); //10KHz 
   MP416_PMode(hDevice,1,10000,0,1);  //1KHZ

   //Sleep(1000);
   //do{
   //set freq mode
   MP416_CMode(hDevice,0,1);
   MP416_CMode(hDevice,1,1);
   
   //clr
   printf("read back mode=%x\n",MP416_inb(hDevice,0x13));
   
   
   
   //Sleep(10);

   //}while(!kbhit());
   ftime(&st);

   
   
   do{


	   l1=MP416_CRead(hDevice,0,&gate);
	   
	   printf(".%2d",gate);

   }while(gate!=0);

   
   ftime(&et);
   Sleep(100);   
   
   
   l1= MP416_CRead(hDevice,0,&gate);
   printf("\n\nCH0 CRead=%d.....",l1);
   printf(" Gate st=%x.....",gate);
   
   if(l1<800)
	   ercnt++;


   printf("\nCH1 CRead=%d.....", MP416_CRead(hDevice,1,&gate));
   printf(" Gate st=%x.....",gate);

 

   i=(et.time) * 1000; 
   i=i+ et.millitm;
   j=(st.time) * 1000;
   j=j+ st.millitm;
   printf("time pass:%d\n",i-j);

   Sleep(100);
   
    //i=0;
	//if(kbhit())
	//	i=getch();

   //}while(i!=27);

   printf("-----------------------------------------------------\n ercnt=%d\n\n",ercnt);
  
   getch();	
	
	
	
	return 0;
}


