// MP416TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MP416Test.h"
#include "MP416TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#pragma comment(lib,"mp416.lib")
#include "mp416.h"

HANDLE hDevice;
long state;
long gain;
long ADData;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP416TestDlg dialog

CMP416TestDlg::CMP416TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMP416TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMP416TestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMP416TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMP416TestDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMP416TestDlg, CDialog)
	//{{AFX_MSG_MAP(CMP416TestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_AD, OnButtonAd)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_DI, OnButtonDi)
	ON_BN_CLICKED(IDC_BUTTON_Timer, OnBUTTONTimer)
	ON_BN_CLICKED(IDC_BUTTON_Pulse, OnBUTTONPulse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP416TestDlg message handlers

BOOL CMP416TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	m_List.InsertColumn( 0, "ͨ", LVCFMT_CENTER, 50, -1 );
	m_List.InsertColumn( 1, "ֵ", LVCFMT_CENTER, 70, -1 );
	m_List.InsertColumn( 2, "ѹֵ(V)", LVCFMT_CENTER, 77, -1 );
	
	for(int i=0; i<16; i++)
	{
		CString a;
		a.Format("%i",i);
		m_List.InsertItem(i,a);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMP416TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMP416TestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMP416TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CAboutDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	
	
	return 0;
}

int CMP416TestDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	hDevice=INVALID_HANDLE_VALUE;
	
	hDevice=MP416_OpenDevice(0);

	if(hDevice==INVALID_HANDLE_VALUE)
	{
		Beep(1000,300);
		AfxMessageBox("Error Open MP416, Check Driver or USB Device");
		exit(0);
	}
	else
	{
			state=0;
			gain=2;
	}
	
	return 0;
}

void CMP416TestDlg::OnButtonAd() 
{
	// TODO: Add your control notification handler code here
	if (state==0) 
	{
		GetDlgItem(IDC_BUTTON_AD)->SetWindowText("ֹͣAD");
		state=1;
		MP416_AD_CAL(hDevice);//ûڿʼ֮ǰһMP416_AD_CAL()
		                      //ADһУ
		                       //ÿ60ӽһMP416_AD_CAL()
	                          //ܹЧԶ¶ȱ仯
		SetTimer(1,100,NULL);
	}
	else
	{
		GetDlgItem(IDC_BUTTON_AD)->SetWindowText("AD");
		state=0;
		KillTimer(1);

	}
	
}

void CMP416TestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
	if(nIDEvent==1)
	{
		for(int i=0; i<=15; i++)
		{
			m_List.SetItemText(i, 1, "");
		    m_List.SetItemText(i, 2, "");
		}
		for(int ch=0;ch<=15;ch++)
		{
			ADData=MP416_AD(hDevice,ch,gain,0,1);
        
	      	CString a,b;
	    	a.Format("%d",ADData);
		
		if(gain==0)
		{
			b.Format("%.3f",ADData*5/65535.0);
		}
		else if(gain==1)
		{
			b.Format("%.3f",ADData*10/65535.0);

		}
		else if(gain==2)
		{
			b.Format("%.3f",(ADData-32768.0)*5/32768.0);
		}
		else
		{
			b.Format("%.3f",(ADData-32768.0)*10/32768.0);
		}
	
		 m_List.SetItemText(ch, 1, a);
         m_List.SetItemText(ch, 2, b);
	}
	}
	else
	{
		long count,a;
	    count=MP416_CRead(hDevice,0,&a);
		if (count==-1)
	{
		GetDlgItem(IDC_EDIT_Count)->SetWindowText("洦");
	}
	else
	{
		CString aa;
	    aa.Format("%d",count);
	    GetDlgItem(IDC_EDIT_Count)->SetWindowText(aa);
	}
	}
}
void CMP416TestDlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
   MP416_PMode(hDevice,0,0,0,0);  //set pulse out disable
   MP416_PMode(hDevice,1,0,0,0);  //set pulse out disable
   MP416_DO(hDevice, 0x55AA);
	
}

void CMP416TestDlg::OnButtonDi() 
{
	// TODO: Add your control notification handler code here
	long DIData;
	DIData=MP416_DI(hDevice);
	CString DI;
	DI.Format("0x%x", DIData);
	GetDlgItem(IDC_EDIT_DI)->SetWindowText(DI);
}

void CMP416TestDlg::OnBUTTONTimer() 
{
	// TODO: Add your control notification handler code here
	MP416_CMode(hDevice,0,0);//ʱ0

	SetTimer(2,100,NULL);
}

void CMP416TestDlg::OnBUTTONPulse() 
{
	// TODO: Add your control notification handler code here
	
		MP416_PMode(hDevice,0,10,0,1);
}
